﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LJLib.Net.SPI.Com;
using Microsoft.SqlServer.Server;

namespace JLHHJSvr.Com
{
    /// <summary>
    /// 修改密码
    /// </summary>
    public sealed class ChangePasswordRequest : ILJRequest<ChangePasswordResponse>
    {
        /// <summary>
        /// 登录后,获得token
        /// </summary>
        public string account { get; set; }
        /// <summary>
        /// 需要修改的userid
        /// </summary>
        public string userid { get; set; }
        /// <summary>
        /// 旧密码
        /// </summary>
        public string oldpassword { get; set; }

        /// <summary>
        /// 新密码
        /// </summary>
        public string newpassword { get; set; }

        public override string GetApiName()
        {
            return "ChangePassword";
        }

    }

    /// <summary>
    /// 修改成功则ErrMsg为null,否则ErrMsg保存错误信息
    /// </summary>
    public sealed class ChangePasswordResponse : LJResponse
    {
    }
}
