﻿using LJLib.DAL.SQL;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace JLHHJSvr.Com.Model
{
    [PK(new[] { "mtrlid,mtrlcode" })]
    public sealed class L1Mtrldef
    {
        public int? mtrlid { get; set; }
        public string mtrlcode { get; set; }
        public string mtrlname { get; set; }
        public int? mtrlorigin { get; set; }
        public string mtrltype { get; set; }
        public string handtype { get; set; }
        public string unit { get; set; }
        public string mtrlmode { get; set; }
        public string mtrlsectype { get; set; }
        public string zxmtrlmode { get; set; }
        public string usermtrlmode { get; set; }
        public string mtrlengname { get; set; }
        public string material { get; set; }
        public string barcode { get; set; }
        public string dscrp { get; set; }
        public int? issuliao { get; set; }
        public int? isuse { get; set; }
        //public byte? iflimitprice { get; set; }
        public decimal? net_weight { get; set; }
        public decimal? gross_weight { get; set; }
        public decimal? cubage { get; set; }
        public string prdpackcode { get; set; }
        public DateTime? opdate { get; set; }
        public string opemp { get; set; }
        public int? buyunit { get; set; }
        public int? buydec { get; set; }
        public string unit_buy { get; set; }
        public string unit_scll { get; set; }
        public string unit_sale { get; set; }
        public decimal rate_buy { get; set; }
        public decimal rate_scll { get; set; }
        public decimal rate_sale { get; set; }
        public decimal saleunit { get; set; }
        public int? price_ifpz_buy { get; set; }
        public int? iflimitprice { get; set; }
        public int? flag { get; set; }
        public int? statustype { get; set; }
        public int? woodcodetype { get; set; }
        public int? pcodetype { get; set; }

        public string mtrloriginStr
        {
            get
            {
                switch (mtrlorigin)
                {
                    case 0:
                        return "自制产品";
                    case 1:
                        return "产品包装件";
                    case 2:
                        return "采购";
                    case 3:
                        return "外协部件";
                    case 4:
                        return "自制部件";
                }
                return string.Empty;
            }
            set { }
        }

        public string issuliaoStr
        {
            get
            {
                switch (issuliao)
                {
                    case 0:
                        return "普通物料";
                    case 4:
                        return "玻璃";
                    case 5:
                        return "纸箱";
                }
                return string.Empty;
            }
            set { }
        }
        public int? status_check { get; set; }
        public int? woodcode_check { get; set; }
        public int? pcode_check { get; set; }
        public byte? statusflag { get; set; }
        public byte? woodcodeflag { get; set; }
        public byte? pcodeflag { get; set; }
        public byte? Mtrlorigin { get; set; }
        public decimal? LMsaleprice { get; set; }
        public decimal? gbrate { get; set; }
        public int? ifcheckaddqty { get; set; }
        public string strcheckaddqty { get; set; }
        public string woodcode_config { get; set; }
        public string rowNum { get; set; }
        public string status_config { get; set; }
        public string woodcode_configName { get; set; }
        public string status_configName { get; set; }
        public decimal? quoteqty { get; set; }
        #region mtrlware
        public decimal? noallocqty { get; set; }
        #endregion
        /// <summary>
        /// 主图MD5
        /// </summary>
        public string picmd5 { get; set; }
        public string storagename { get; set; }
        /// <summary>
        /// 单价
        /// </summary>
        public decimal? price { get; set; }
        public decimal? taxrate { get; set; }
        public decimal? rebate { get; set; }

        /// <summary>
        /// 原价
        /// </summary>
        public decimal? price_ori { get; set; }
        /// <summary>
        /// 参考装柜量
        /// </summary>
        public decimal? ck_packqty { get; set; }
        /// <summary>
        /// 价格表币种
        /// </summary>
        public int moneyid { get; set; }
        public int fjcnt { get; set; }

        public decimal kcqty { get; set; }
        public decimal xqqty { get; set; }
        public decimal maxqty { get; set; }
        /// <summary>
        /// 配置1默认值
        /// </summary>
        public string dftStatus { get; set; }
        /// <summary>
        /// 配置2默认值
        /// </summary>
        public string dftWoodcode { get; set; }
        /// <summary>
        /// 配置3默认值
        /// </summary>
        public string dftPcode { get; set; }
        /// <summary>
        /// 分部id
        /// </summary>
        public int? scid { get; set; }
        public int? storageid { get; set; }
        public int? mtrltypeid { get; set; }
        public int? mtrlprp { get; set; }
        public string plancode { get; set; }

    }

}
