﻿using LJLib.DAL.SQL;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace JLHHJSvr.Com.Model
{
    [PK(new[] { "wrkGrpid", "wrkgrpcode" })]
    public sealed class u_sc_workgroup_erp
    {
        public int? wrkGrpid { get; set; }
        public string wrkgrpcode { get; set; }
        public string wrkGrpName { get; set; }
        public byte? ifjj { get; set; }
        public byte? ifprint { get; set; }
        public string handtype { get; set; }
        public byte? sonflag { get; set; }
        public int? parentid { get; set; }
        public byte? inuse { get; set; }
        public int? storageid { get; set; }
        public DateTime? opdate { get; set; }
        public string opemp { get; set; }
        public DateTime? moddate { get; set; }
        public string modemp { get; set; }
        public byte? ifwkpmtrlware { get; set; }
        public string dscrp { get; set; }
        public int? empnum { get; set; }
        public decimal? avggz { get; set; }
        /// <summary>
        /// 工组进度生成模式
        /// [0]按工组交接数统计
        /// [1]按工组末工序计件确认数统计
        /// [2]按末工序计件确认数更新工组完成数统计
        /// [3]工序完工单（末工序）更新工组完工数
        /// [4]工序完工单（末工序）更新工艺完工数以及工组完工数
        /// [5]工艺完工单更新工组完工数
        /// [6]部件条码更新工组完工数
        /// [7]按工组质检单
        /// [8]工序完工单（所有工序配套数）更新工组完工数
        /// [9]工组配套完成数，按已完成的工价百分比更新
        /// </summary>
        public byte? jdtype { get; set; }
        public int? jdnum { get; set; }
        /// <summary>
        /// 工组类型0-工组日历 1-工作中心日历
        /// </summary>
        public int? tasktype { get; set; }
        public DateTime? sys_changetime { get; set; }
        public decimal? userate { get; set; }
        public int? deptid { get; set; }
        public decimal? OTHour { get; set; }
        public decimal? shortrate { get; set; }
        public int? iflastfinish { get; set; }
        public int? barcode_check { get; set; }
        public byte? ifauto_mode { get; set; }
        public byte? ifbj { get; set; }
        public decimal? jjamt { get; set; }
        /// <summary>
        /// 0-派工单核实即完工；1-工位机接工方可完工；2-工组完工需要考虑下工组接收数
        /// </summary>
        public byte? finflowop { get; set; }
        /// <summary>
        /// 工组添加列 工位机工序派工流程选项 0-不限制工序派工 1-本工组配套接收才可派工
        /// </summary>
        public byte? proflowop { get; set; }
        /// <summary>
        /// 工位机小组质检分值录入方式[0-质检完工时录入][1-月尾批更新][2-先完工后评分]
        /// </summary>
        public byte? fenop { get; set; }

        public int? gw_empid { get; set; }

        public byte? ifkey { get; set; }
        /// <summary>
        /// 订单评审忽略产能
        /// </summary>
        public byte? SO_IgnoreCapacity { get; set; }
        /// <summary>
        /// 产能模式[0]工时 [1]工资 [2]套数 [3]工段折算套数 [-1]按工段属性
        /// </summary>
        public int? loadmode { get; set; }
        public string simplename { get; set; }

        /// <summary>
        /// DONE:工位机工序交接主管代号,替代gw_empid的作用
        /// </summary>
        public string gw_mastercode { get; set; }
        /// <summary>
        /// TODO:本工组完成后是否需要交给后工组
        /// </summary>
        public byte? gw_ifprojj { get; set; }
        /// <summary>
        /// 是否允许派工后直接完工(0-不允许，1-允许)
        /// </summary>
        public int? ifdirectfinish { get; set; }
        /// <summary>
        /// 接报工模式：0：默认，手动接工，手动报工
        /// </summary>
        public int? acceptMode { get; set; }
        /// <summary>
        /// 完工模式：0，手动，1自动
        /// </summary>
        public int? finishMode { get; set; }

        public int? piecemonthmode { get; set; }
    }

}
